# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import playerlib
import popuplib
import keyvalues
# ============================================================================================================================================================= #

# * SAM IMPORTS
func    = es.import_addon('sam/functions')
admins  = es.import_addon('sam/admins')

# * VARIABLES
db     = 'sam_groups'
dbfile = 'cstrike/cfg/sam/databases/es_%s_db.txt' % db

temp   = {'cancel':None}

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load/Create DB ###
	if checkDB(): es.keygroupload(db, func.dbfiles)

	### Update Groups Accesses ###
	if es.exists('keygroup', db): updateGroups()

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Deletes ###
	es.keygroupdelete(db)

	### Popups ###
	func.popupDelete('groups_getGroup')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def startFilter(userid):
	temp[userid] = 'setgroup'
	es.addons.registerSayFilter(setFilter)
	func.tell(userid, func.lang_groups('type_name'), func.adminstag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def create(userid, group):
	if not es.exists('keygroup', db): es.keygroupcreate(db)
	block = es.import_addon('sam/base/manager')
	group = group.replace(group[0], group[0].upper())
	if not es.exists('key', db, group):
		es.keycreate(db, group)
		es.keysetvalue(db, group, 'name', group)
		es.keysetvalue(db, group, 'immunity', 0)
		for x in admins.access: es.keysetvalue(db, group, x, 'no')
		es.keygroupsave(db, func.dbfiles)
		edit_group(userid, group, None)
		func.hudhint(userid, func.lang_groups('group_created', {'name':group}), func.admins_hudtag)
	else:
		func.hudhint(userid, func.lang_groups('group_exists', {'name':group}), func.admins_hudtag)
		block = es.import_addon('sam/base/manager')
		block.modulePopup(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def delete(userid, group, popup):
	group = get(group)
	block = es.import_addon('sam/base/manager')
	block.modulePopup(userid)
	func.hudhint(userid, func.lang_groups('group_deleted', group), func.admins_hudtag)
	es.keydelete(db, group['name'])
	es.keygroupsave(db, func.dbfiles)
	for admin in keyvalues.getKeyGroup(admins.db):
		target = admins.getAdmin(admin)
		if target['group'] == group['name']:
			es.keysetvalue(admins.db, target['steamid'], 'group', 'None')
			es.keygroupsave(admins.db, func.dbfiles)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def edit_group(userid, group, popup, page = None):
	temp[userid] = None
	group = get(group)
	if group:
		func.popupDelete('manager_edit')
		popup = popuplib.easymenu('manager_edit', None, editgroup_Choice)
		popup.c_beginsep = func.pline + '\n# %s: %s\n ' % (func.lang_word('group'),group['name'])
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s' % func.lang_groups('edit_group'))
		popup.addoption({'item':'immunity','group':group}, '%s: %s' % (func.lang_word('immunity'), group['immunity']))
		for item in admins.access: popup.addoption({'item':item,'group':group}, '%s: %s' % (item, func.lang_word(group[item])))
		popup.submenu(10, 'manager')
		if page != None: popup.sendPage(userid, page)
		else: popup.send(userid)
	else:
		func.tell(userid, func.lang_groups('not_an_group'))
		modulePopup(userid)

# ---------------------------------------------------------------------------------------------------------------------------------------------------- #
def editgroup_Choice(userid, choice, popup):
	group = choice['group']
	data  = admins.access
	if choice['item'] != 'immunity': page = func.getPage(data.index(choice['item']) + 1, 7)
	else: page = 1
	if temp[userid] == None:
		if choice['item'] == 'immunity':
			temp[userid] = group['name']
			es.addons.registerSayFilter(setFilter)
			func.tell(userid, func.lang_admins('immunity_get_value'), func.adminstag)
		else:
			if es.keygetvalue(db, group['name'], choice['item']) == 'yes': es.keysetvalue(db, group['name'], choice['item'], 'no')
			elif es.keygetvalue(db, group['name'], choice['item']) == 'no': es.keysetvalue(db, group['name'], choice['item'], 'yes')
			es.keygroupsave(db, 'sam/databases')
			edit_group(userid, group['name'], popup, page)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def exists(group):
	if es.exists('keygroup', db):
		if es.exists('key', db, group): return True
		else: return False
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def get(group):
	target = {'name':es.keygetvalue(db, group, 'name'),'immunity':es.keygetvalue(db, group, 'immunity')}
	for item in admins.access: target[item] = es.keygetvalue(db, group, item)
	return target

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def updateGroups():
	if checkDB() and es.exists('keygroup', db):
		for group in keyvalues.getKeyGroup(db):
			for item in admins.access:
				if not es.exists('keyvalue', db, group, item): es.keysetvalue(db, group, item, 'no')
		es.keygroupsave(db, func.dbfiles)

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def setFilter(userid, text, teamonly):
	if temp[userid] == 'setgroup':
		if not text == '!cancel': create(userid, text)
		else:
			block = es.import_addon('sam/base/manager')
			block.modulePopup(userid)
			func.hudhint(userid, func.lang_base('op_canceled'), func.server_hudtag)
		temp[userid] = None
		es.addons.unregisterSayFilter(setFilter)
		return (0, 0, 0)
	elif not temp[userid] == None:
		if not text == '!cancel':
			try:
				if int(text.strip('"')) in range(0,101):
					es.addons.unregisterSayFilter(setFilter)
					es.keysetvalue(db, temp[userid], 'immunity', text)
					es.keygroupsave(db, func.dbfiles)
					edit_group(userid, temp[userid], None)
					temp[userid] = None
				else: func.tell(userid, func.lang_admins('immunity_wrong_range'), func.adminstag)
			except: func.tell(userid, func.lang_admins('immunity_wrong_range'), func.adminstag)
		else:
			temp[userid] = None
			es.addons.unregisterSayFilter(setFilter)
			editChoice(userid, target, None)
			func.hudhint(userid, func.lang_base('op_canceled'), func.server_hudtag)
		return (0, 0, 0)
	else: return (userid, text, teamonly)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def chooseGroup(userid, num):
	func.popupDelete('groups_getGroup')
	if num == 5:   popup = popuplib.easymenu('groups_getGroup', None, delete)
	elif num == 6: popup = popuplib.easymenu('groups_getGroup', None, edit_group)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	choice = {5:'delete',6:'edit'}
	popup.setdescription('\n \n :: %s\n# %s' % (func.lang_titles('manager_groups_name'), func.lang_titles('manager_groups_%s_desc' % choice[num])))
	for item in keyvalues.getKeyGroup(db): popup.addoption(item, es.keygetvalue(db, item, 'name'))
	popup.submenu(10, 'manager')
	popup.send(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkDB():
	if os.path.isfile(dbfile) == True: return True
	else: return False

# ============================================================================================================================================================= #