# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import cmdlib
import playerlib
import gamethread
import time
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Spawn Protection'
addon.basename = 'spawnp'
addon.status   = 0
addon.version  = '1.0.p'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES

spawnptag = 'SPAWN PROTECTION'
temp      = {'intime':0, 'ptime':10, 'stamp':0}

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

	cmdlib.registerServerCommand('sam_spawn_protection_length', spawnp_timeCMD, 'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)

	### SV CMD ###
	cmdlib.unregisterServerCommand('sam_spawn_protection_length')

	### TAKE PROTECTION ###
	if temp['stamp'] > int(time.time()): stop()

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def spawnp_timeCMD(args):
	if args and len(args) == 1:
		try:
			global ptime
			temp['ptime'] = int(args[0])
		except: pass

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def give_protection(target):
	god = es.import_addon('sam/base/pcontrol/godmode')
	god.setgodmode(target)
	if target.teamid == 3: target.setColor(0,0,255,100)
	elif target.teamid == 2: target.setColor(255,0,0,100)
	protected_msg(target)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def take_protection(target):
	god = es.import_addon('sam/base/pcontrol/godmode')
	god.unsetgodmode(target)
	target.setColor(255,255,255,255)
	func.hudhint(target, func.lang_addon(addon.basename, 'unprotected'), spawnptag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def protected_msg(target):
	if temp['intime'] == 1:
		func.hudhint(target, func.lang_addon(addon.basename, 'protected'), spawnptag)
		gamethread.delayed(1, protected_msg, (target))

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def round_start(ev):
	temp['stamp'] = int(time.time()) + temp['ptime']
	freeze = es.ServerVar('mp_freezetime')
	gamethread.delayed(freeze, start, ())
	gamethread.delayed(temp['ptime'] + freeze, stop, ())

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def player_spawn(ev):
	if temp['stamp'] > int(time.time()): give_protection(playerlib.getPlayer(ev['userid']))

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def start():
	temp['intime'] = 1
	for ply in playerlib.getPlayerList('#alive'): give_protection(ply)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def stop():
	temp['intime'] = 0
	for ply in playerlib.getPlayerList('#alive'): take_protection(ply)

# ============================================================================================================================================================= #